unit fTestData;

{
   Package: TIU - TEXT INTEGRATION UTILITIES
   Date Created: Oct 23, 2006
   Site Name: Alexandria, VAMC
   Developers: Shawn Elliott, SGT
   Description: Mobile Electronic Documentation
   Note: This unit requires XWB*1.1 and TIU*1*244 in order to run.
         Includes Template routines from CPRS
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uPatient, VA508AccessibilityManager, ComCtrls;

type
  TfrmTestData = class(TForm)
    lblID: TLabel;
    edtID: TEdit;
    lblName: TLabel;
    edtName: TEdit;
    lblAge: TLabel;
    edtAge: TEdit;
    lblSex: TLabel;
    edtSex: TEdit;
    lblSSN: TLabel;
    edtSSN: TEdit;
    lblHS: TLabel;
    btnSave: TButton;
    lblDOB: TLabel;
    edtDOB: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    { TODO -oHERB -c508 : TMemo was not being read by JAWS so it was replaced with a TRichEdit }
//    memHS: TMemo;
    memHS: TRichEdit;
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTestData: TfrmTestData;

implementation

{$R *.DFM}

procedure TfrmTestData.btnSaveClick(Sender: TObject);
var
  patImp: TPatRecord;
begin
  //Set patient data
  patImp := TPatRecord.Create;
{ TODO -oHerb -cSACC : Change prefix txt to edt }
  //Create the data
{ TODO -oherb -cInvalid Integer : 
Still having invalid integer issues.  Changing integer to INt64 to fix
the problem.  12/17/2009 }
//  patImp.DFN := StrToInt(edtID.Text);
  patImp.DFN := StrToInt64(edtID.Text);
  patImp.Name := edtName.Text;
  patImp.SSN := edtSSN.Text;
  patImp.Sex := edtSex.Text;
  patImp.DOB := edtDOB.Text;
  patImp.HealthSumm := memHS.Lines.GetText;

  //And save
  if patImp.SavePatient = false then
    { TODO -oHerb -c508 : TODO -oHerb -c508 : Replace ShowMessage with MessageBox - Matt Greener said JAWS could not read the text }
//    ShowMessage('Error saving patient')
    { TODO -oHerb -c2/27/2010 Make MessageBox Modal : Need to make MessageBox Modal to owner. }
//    MessageBox(0, PChar('Error saving patient'), 'Error', MB_OK)
{ TODO -oherb -c3/1/2010 Make MessageBox Modal : Changing the actual frm reference to self to be fix issue with TfrmGetPat locking up }
//    MessageBox( frmTestData.Handle, PChar('Error saving patient'), 'Error', MB_OK)
    MessageBox( self.Handle, PChar('Error saving patient'), 'Error', MB_OK)
  else
    Self.Close;
end;

end.
